Ext.define('mcs.Support', {singleton:true, helper:{getSetting:function(instanceId, settingName) {
  return BpcCommon.Api.getSetting(instanceId, settingName);
}, getBackendConnectionRootPath:function(instanceId) {
  return BpcCommon.Api.getBackendUrl(instanceId);
}}, features:{messaging:{defaultConfig:function(moduleId) {
  return {'addressesEndPoint':BpcCommon.Api.getSetting(moduleId, 'aMessaging_addressesEndPoint'), 'endPoint':BpcCommon.Api.getSetting(moduleId, 'aMessaging_endPoint'), 'submitUrl':BpcCommon.Api.getSetting(moduleId, 'aMessaging_endPoint'), 'displayText':BpcCommon.Api.getSetting(moduleId, 'aMessaging_displayText'), 'columnPartner':BpcCommon.Api.getSetting(moduleId, 'aMessaging_columnPartner'), 'comparedColumn':BpcCommon.Api.getSetting(moduleId, 'aMessaging_comparedColumn'), 'comparedColumnValue':BpcCommon.Api.getSetting(moduleId, 
  'aMessaging_comparedColumnValue'), 'title':BpcCommon.Api.getSetting(moduleId, 'aMessaging_customTitle'), 'messageTexts':BpcCommon.Api.getSetting(moduleId, 'aMessaging_messageTexts')};
}, createAlternativeMessagingPanel:function(selection, moduleId, getCfgOnly) {
  var config = mcs.Support.features.messaging.defaultConfig(moduleId);
  var processIDKey = BpcCommon.Api.getSetting(moduleId, 'field_processId');
  var processIds = [];
  var columnPartnerCode = config.columnPartner;
  if (selection && selection.length > 0) {
    var chkPartnerCode = selection[0].get(columnPartnerCode.toUpperCase());
    if (mcs.Support.util.isEmpty(processIDKey)) {
      processIDKey = 'processId';
    }
    for (var i = 0; i < selection.length; i++) {
      processIds.push(selection[i].get(processIDKey.toUpperCase()));
    }
    if (config.endPoint && config.submitUrl && config.addressesEndPoint) {
      var cfg = {processIds:processIds, chkPartnerCode:chkPartnerCode, configuration:{moduleId:moduleId}};
      if (getCfgOnly) {
        return cfg;
      } else {
        cfg.xtype = 'alternativeMessagePanel';
        return cfg;
      }
    } else {
      Ext.toast('Fehler beim alternativen Nachrichtenversand, Konfiguration fehlerhaft');
    }
  }
}}}, assets:{toolbarRightAlternativeMessage:'fa-envelope', toolbarRightAlternativeMessageTooltip:'Alternativer Nachrichtenversand'}, rights:{alternativeMessageTransfer:'plugin_gascade_alternativeMessageTransfer', mscons:'plugin_gascade_mscons', exportPartnerManagement:'plugin_gascade_exportPartnerManagement'}, util:{isEmpty:function(element) {
  if (typeof element === 'undefined') {
    return true;
  }
  if (typeof element === 'boolean' && (element === true || element === false)) {
    return false;
  }
  if (element === null) {
    return true;
  }
  if (element.length > 0) {
    return false;
  }
  if (element.length === 0) {
    return true;
  }
  for (var key in element) {
    if (hasOwnProperty.call(element, key)) {
      return false;
    }
  }
  if (typeof element === 'number') {
    return isNaN(element);
  }
  return true;
}, parseXML:function(dataInString) {
  if (window.DOMParser) {
    return (new window.DOMParser()).parseFromString(dataInString, 'text/xml');
  } else if (typeof window.ActiveXObject != 'undefined' && new window.ActiveXObject('Microsoft.XMLDOM')) {
    var xmlDoc = new window.ActiveXObject('Microsoft.XMLDOM');
    xmlDoc.async = 'false';
    xmlDoc.loadXML(dataInString);
    return xmlDoc;
  } else {
    return null;
  }
}, toXML:function(value) {
  return Ext.util.Format.htmlEncode(value);
}, toAtomXML:function(name, value) {
  return '\x3c' + name + '\x3e' + mcs.Support.util.toXML(value) + '\x3c/' + name + '\x3e';
}, toBeginXML:function(name, type) {
  if (type == 'atom' || Ext.isEmpty(type)) {
    type = '';
  } else {
    type = ' type\x3d"' + mcs.Support.util.toXML(type) + '"';
  }
  return '\x3c' + name + type + '\x3e';
}, toEndXML:function(name) {
  return '\x3c/' + name + '\x3e';
}, ajaxPostXMLCall:function(url, data, callback) {
  Ext.Ajax.request({url:url, method:'POST', xmlData:data, headers:{'Content-Type':'application/xml'}, scope:this, callback:function(options, success, response) {
    callback(success, response);
  }});
}}, translationPrefix:'MCS', getTranslation:function(key) {
  key = (key || '').toUpperCase();
  var prefix = this.translationPrefix + '_';
  if (!key.startsWith(prefix)) {
    key = prefix + key;
  }
  return BpcCommon.Api.getTranslation(key);
}, TR:function(k) {
  return this.getTranslation(k);
}, faIcon:function(fontAwesomeName) {
  return BpcCommon.util.Icons.getBpcIconCls(fontAwesomeName);
}, copyToClipBoard:function(text, extCmp) {
  function copyToClp(stringWithNewLines) {
    try {
      var myFluffyTextarea = document.createElement('textarea');
      myFluffyTextarea.innerHTML = stringWithNewLines;
      var parentElement = document.getElementById(extCmp.getId());
      parentElement.appendChild(myFluffyTextarea);
      myFluffyTextarea.select();
      document.execCommand('copy');
      parentElement.removeChild(myFluffyTextarea);
      return true;
    } catch (e) {
      return false;
    }
  }
  return copyToClp(text);
}});
Ext.define('mcs.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['mcs.Support'], config:{moduleConfigurationComponents:[], requiredModules:[], widgets:[]}});
Ext.define('mcs.components.LoadingPanel', {extend:'Ext.panel.Panel', alias:'widget.mcsLoadingPanel', layout:'fit', initComponent:function() {
  this.messagePanel = Ext.create({xtype:'container', width:'400', height:'150', html:''});
  this.setMessage();
  this.items = [{xtype:'container', layout:'center', items:[this.messagePanel]}];
  this.callParent(arguments);
}, setMessage:function(message, icon, color, size) {
  message = message || mcs.Support.TR('GENERIC_LOADING');
  icon = icon || 'fa-cogs';
  color = color || '#000';
  size = size || 40;
  var html = '\x3cdiv style\x3d"display: flex; flex-direction: column; justify-content: center; justify-items: center; align-items: center; padding: 30px;"\x3e' + '\x3cdiv style\x3d"padding: 10px;"\x3e' + BpcCommon.util.Icons.getSpanForIconCls(BpcCommon.util.Icons.getBpcIconCls(icon), color, size) + '\x3c/div\x3e' + '\x3cdiv style\x3d"padding: 10px;"\x3e' + message + '\x3c/div\x3e' + '\x3c/div\x3e';
  this.messagePanel.update(html);
}});
Ext.define('mcs.components.Tree', {extend:'Ext.tree.Panel', alias:'widget.mcsLinkTree', margin:'5 5 5 5', rootVisible:true, infoButton:undefined, pathButton:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.columns = [{xtype:'treecolumn', text:mcs.Support.TR('PATH'), dataIndex:'name', flex:4}, {dataIndex:'color', width:40, renderer:function(val, meta, rec) {
    if (val && val.length) {
      meta.tdAttr = 'bgcolor\x3d"' + val + '"';
    }
    return '';
  }}, {xtype:'actioncolumn', width:60, items:[{iconCls:mcs.Support.faIcon('fa-clone'), handler:function(grid, rowIndex, colIndex, item, event, rec) {
    $jscomp$this.copyText(rec.get('url'));
  }, isActionDisabled:function(v, r, c, item, record) {
    var url = record.get('url');
    return !Ext.isDefined(url) || url.length === 0;
  }}, {iconCls:mcs.Support.faIcon('fa-external-link'), handler:function(grid, rowIndex, colIndex, item, event, rec) {
    window.open(rec.get('url'), '_blank');
  }, isActionDisabled:function(v, r, c, item, record) {
    var url = record.get('url');
    return !Ext.isDefined(url) || url.length === 0;
  }}]}, {text:mcs.Support.TR('URL'), dataIndex:'url', flex:4}, {text:mcs.Support.TR('DESCRIPTION'), dataIndex:'description', flex:2}];
  this.listeners = {rowdblclick:function(tv, record, element) {
    if (record) {
      var url = record.get('url');
      if (url) {
        $jscomp$this.copyText(url);
      }
    }
  }};
  this.callParent(arguments);
  this.expandAll();
}, copyText:function(txt) {
  if (mcs.Support.copyToClipBoard(txt, this)) {
    BpcCommon.Api.showNotification('URL:  ' + txt + ' wurde kopiert');
  }
}});
Ext.define('mcs.AlternativeMessagePlugin', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'MCS - Alternativer Emailversand - DetailWindow', PLUGIN_ID:'mcsAlternativeMessagePluginDetailWindow', COMPONENT_XTYPE:'alternativeMessagePanel'}});
Ext.define('mcs.AlternativeMessagePlugin', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'MCS - Alternativer Emailversand - Button', PLUGIN_ID:'mcsAlternativeMessagePluginBtn', COMPONENT_XTYPE:'mcsAlternativeMessagingButton'}});
Ext.define('mcs.AperakPlugin', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'MCS - Aperak View', COMPONENT_XTYPE:'mcsAperakView', PLUGIN_ID:'mcsAperakPlugin'}});
Ext.define('mcs.view.Main', {extend:'Ext.container.Container', alias:'widget.mcsMain', requires:['mcs.Support'], layout:'fit', initComponent:function() {
  this.linkView = Ext.create({xtype:'container', layout:{type:'hbox', align:'stretch'}, items:[]});
  this.items = [this.linkView];
  this.callParent(arguments);
  var json = BpcCommon.Api.getSetting(this.moduleId, 'linkConfig') || [];
  this.linkView.add(this.createTree(json));
}, createTree:function(json) {
  var store = Ext.create('Ext.data.TreeStore', {root:{text:'Links', expanded:true, children:json}});
  return Ext.create({xtype:'mcsLinkTree', store:store, flex:1});
}});
Ext.define('mcs.view.alternativeMessage.AlternativeMessagePanel', {extend:'Ext.form.Panel', alias:'widget.alternativeMessagePanel', requires:['mcs.Support'], iconCls:BpcCommon.util.Icons.getBpcIconCls(mcs.Support.assets.toolbarRightAlternativeMessage), title:'Alternativer Nachrichtenversand', mixins:['BpcCommon.mixin.PsPluginMixin'], padding:5, layout:{type:'vbox', align:'stretch'}, autoScroll:true, processIds:undefined, chkPartnerCode:undefined, configuration:undefined, requestBasePath:undefined, 
requestWasSent:false, moduleId:undefined, mcsInstanceId:undefined, hidden:false, initComponent:function() {
  var $jscomp$this = this;
  var valid = false;
  if (!this.moduleId && !this.mcsInstanceId) {
    this.moduleId = this.getValueFromPluginConfiguration('instanceId', true);
    this.mcsInstanceId = this.getValueFromPluginConfiguration('srcModuleId');
    this.record = this.getValueFromPluginConfiguration('record', true);
    var cfg = mcs.Support.features.messaging.createAlternativeMessagingPanel([this.record], this.mcsInstanceId, true);
    if (cfg) {
      var isValid = function(selection, mcsInstanceId) {
        var enableSendMessageBnt = true;
        if (0 !== selection.length) {
          var columnPartnerCode = BpcCommon.Api.getSetting(mcsInstanceId, 'aMessaging_columnPartner');
          var chkPartnerCode = selection[0].get(columnPartnerCode.toUpperCase());
          var neededColumn = BpcCommon.Api.getSetting(mcsInstanceId, 'aMessaging_comparedColumn');
          var neededValue = BpcCommon.Api.getSetting(mcsInstanceId, 'aMessaging_comparedColumnValue');
          for (var i = 0; i < selection.length; i++) {
            var record = selection[i];
            if (record.get(neededColumn.toUpperCase()) !== neededValue) {
              enableSendMessageBnt = false;
              break;
            } else {
              if (record.get(columnPartnerCode.toUpperCase()) !== chkPartnerCode) {
                enableSendMessageBnt = false;
                break;
              }
            }
          }
          return enableSendMessageBnt;
        }
        return !enableSendMessageBnt;
      };
      if (isValid([this.record], this.mcsInstanceId)) {
        Ext.apply(this, cfg);
      } else {
        this.moduleId = undefined;
      }
    }
  }
  var getMessageText = function(messageTexts) {
    if (messageTexts) {
      var result = '';
      var keys = Ext.Object.getKeys(messageTexts);
      Ext.Array.each(keys, function(key, index, array) {
        result += messageTexts[key];
        if (index < array.length - 1) {
          result += '\n\n----------------------------------------------------------------------------\n';
        }
      });
      return result;
    }
  };
  if (this.moduleId) {
    var proxyId = mcs.Support.helper.getSetting(this.moduleId, 'inubit_proxyId');
    var baseUrl = mcs.Support.helper.getSetting(this.moduleId, 'inubit_baseUrl');
    if (proxyId && baseUrl) {
      this.requestBasePath = mcs.Support.helper.getBackendConnectionRootPath(proxyId) + baseUrl;
    }
    this.mailAddressesField = Ext.create({xtype:'textfield', name:'mailAddresses', itemId:'mailAddresses', fieldLabel:'Empfängeradresse(n)', emptyText:'Bitte Emailadresse(n) eintragen', allowBlank:false, labelWidth:130});
    this.messageField = Ext.create({xtype:'textareafield', grow:true, name:'message', fieldLabel:'Nachrichtentext', itemId:'messageText', allowBlank:false, value:getMessageText(mcs.Support.helper.getSetting(this.mcsInstanceId, 'aMessaging_messageTexts')), labelWidth:130});
    this.items = [{xtype:'box', margin:10, padding:'10 10 10 10', style:{borderStyle:'dotted', borderWidth:'thin'}, html:mcs.Support.helper.getSetting(this.mcsInstanceId, 'aMessaging_displayText')}, this.mailAddressesField, this.messageField];
    this.buttons = [{text:'Abbrechen', itemId:'cancel', view:this, handler:function(btn) {
      btn.view.onCancel();
    }}, {text:'Versenden', formBind:true, disabled:true, view:this, itemId:'sendMessage', handler:function(btn) {
      var form = $jscomp$this.getForm();
      if (form.isValid()) {
        $jscomp$this.sendMessage({processes:($jscomp$this.processIds || []).join(' ').trim(), command:'alternativVersand', mailreceivers:$jscomp$this.mailAddressesField.getValue(), mailtext:$jscomp$this.messageField.getValue()});
      }
    }}];
    valid = true;
  } else {
    this.items = [{xtype:'box', html:'config wrong'}];
    this.hidden = true;
  }
  this.callParent(arguments);
  if (valid && this.processIds && this.chkPartnerCode) {
    this.requestMailaddresses(this.processIds, this.chkPartnerCode).then(function(responseText) {
      $jscomp$this.mailAddressesField.setValue(responseText);
    }, function(errorStatus) {
      Ext.log({msg:"Problem in alternative messaging: Couldn't find mail addresses for the processes. The server is not available.", level:'warn'});
    });
  }
}, requestMailaddresses:function(processIds, chkPartnerCode) {
  var processes = '';
  for (var i = 0; i < processIds.length; i++) {
    processes += processIds[i] + ' ';
  }
  var url = this.requestBasePath + mcs.Support.helper.getSetting(this.mcsInstanceId, 'aMessaging_addressesEndPoint');
  var me = this;
  return new Ext.Promise(function(resolve, reject) {
    me.requestWasSent = true;
    Ext.Ajax.request({url:url, params:{partnerCode:chkPartnerCode, processIds:processes}, success:function(response) {
      resolve(response.responseText);
    }, failure:function(response) {
      reject(response.status);
    }});
  });
}, sendMessage:function(data) {
  var me = this, url = this.requestBasePath + mcs.Support.helper.getSetting(this.mcsInstanceId, 'aMessaging_endPoint');
  Ext.Ajax.request({url:url, params:data, callback:function(options, success, response) {
    if (success) {
      var json = Ext.decode(response.responseText, true);
      if (json) {
        if (!json.success) {
          var msg = 'Fehlermeldung vom Server';
          if (json.msg) {
            msg += ': ' + json.msg;
          }
          Ext.Msg.alert('Fehler im Workflow', msg);
        } else {
          Ext.Msg.alert('Nachricht abgeschickt', json.msg);
          me.onCancel();
        }
      }
    } else {
      Ext.Msg.alert('Fehler beim Abschicken', 'Der Server ist nicht erreichbar.');
    }
  }});
}, onCancel:function() {
  var tabPanel = this.up('tabPanel');
  if (tabPanel) {
    tabPanel.remove(this);
  } else {
    this.up('window').close();
  }
}});
Ext.define('mcs.view.alternativeMessage.Button', {extend:'Ext.button.Button', alias:'widget.mcsAlternativeMessagingButton', requires:['mcs.Support'], mixins:['BpcCommon.mixin.PsPluginMixin'], iconCls:BpcCommon.util.Icons.getBpcIconCls(mcs.Support.assets.toolbarRightAlternativeMessage), tooltip:mcs.Support.assets.toolbarRightAlternativeMessageTooltip, handler:function(btn) {
  var moduleId = this.getValueFromPluginConfiguration('instanceId', true);
  var mcsInstanceId = this.getValueFromPluginConfiguration('srcModuleId');
  var panel = {xtype:'container', html:'Konfiguration nicht vollständig. Bitte prüfen.'};
  if (moduleId) {
    var monitorCmp = BpcCommon.Api.getModuleInstanceComponent(moduleId);
    if (monitorCmp) {
      var grid = monitorCmp.getActiveGrid();
      if (grid) {
        var selection = grid.getSelectionModel().getSelection();
        if (selection) {
          var obj = btn.updateStateAlternativeMessaging(selection, mcsInstanceId);
          if (obj && obj.success) {
            panel = mcs.Support.features.messaging.createAlternativeMessagingPanel(selection, mcsInstanceId);
            panel.mcsInstanceId = mcsInstanceId;
            panel.moduleId = moduleId;
            Ext.create('Ext.window.Window', {height:700, width:600, layout:'fit', title:'Alternativer Nachrichtenversand', items:[panel]}).show();
          } else {
            var msg = obj.msg ? obj.msg : 'Der Alternative Nachrichtenversand ist nicht möglich.';
            Ext.toast(msg);
          }
        }
      }
    }
  }
}, updateStateAlternativeMessaging:function(selection, mcsInstanceId) {
  var enableSendMessageBnt = true, messageText = undefined;
  if (selection && selection.length) {
    var columnPartnerCode = BpcCommon.Api.getSetting(mcsInstanceId, 'aMessaging_columnPartner');
    var chkPartnerCode = selection[0].get(columnPartnerCode.toUpperCase());
    var neededColumn = BpcCommon.Api.getSetting(mcsInstanceId, 'aMessaging_comparedColumn');
    var neededValue = BpcCommon.Api.getSetting(mcsInstanceId, 'aMessaging_comparedColumnValue');
    for (var i = 0; i < selection.length; i++) {
      var record = selection[i];
      if (record.get(neededColumn.toUpperCase()) !== neededValue) {
        enableSendMessageBnt = false;
        messageText = 'aMessaging_comparedColumn does not match aMessaging_comparedColumnValue';
        break;
      } else {
        if (record.get(columnPartnerCode.toUpperCase()) !== chkPartnerCode) {
          messageText = 'Der Alternativversand ist nicht zeitgleich für Nachrichten unterschiedlicher Partner möglich.';
          enableSendMessageBnt = false;
          break;
        }
      }
    }
  } else {
    enableSendMessageBnt = false;
    messageText = 'Versand nicht möglich, keine Daten ausgewählt';
  }
  return {success:enableSendMessageBnt, msg:messageText};
}});
Ext.define('mcs.view.aperak.AdvancedTextAreaController', {extend:'Ext.app.ViewController', alias:'controller.advancedTextAreaController', currentCommentValue:undefined, init:function() {
  var comment = this.getView().comment;
  this.currentCommentValue = comment === null ? '' : comment;
}, onAfterrender:function() {
  var window = this.getView().up('window');
  var me = this;
  window.on('beforeclose', function() {
    var textArea = me.lookupReference('aperakTextArea');
    var oldValue = me.currentCommentValue;
    if (textArea.getValue() !== me.currentCommentValue) {
      Ext.Msg.show({title:BpcCommon.Api.getTranslation('MONITOR_SAVE_CHANGES'), msg:BpcCommon.Api.getTranslation('MONITOR_SAVE_CHANGES_MSG'), buttons:Ext.Msg.YESNOCANCEL, fn:function(btn) {
        if (btn === 'yes') {
          me.saveData();
          window.close();
        } else if (btn === 'no') {
          textArea.setValue(oldValue);
          me.saveData();
          me.currentCommentValue = oldValue;
          window.close();
        }
      }, icon:Ext.MessageBox.QUESTION, scope:this});
      return false;
    }
  });
}, onCancel:function() {
  var textArea = this.lookupReference('aperakTextArea');
  var newValue = textArea.getValue();
  if (newValue !== this.currentCommentValue) {
    textArea.setValue(this.currentCommentValue);
  }
  textArea.disable();
  textArea.enable();
}, saveData:function() {
  var textArea = this.lookupReference('aperakTextArea');
  var newValue = textArea.getValue();
  if (newValue !== this.currentCommentValue) {
    var requestData = this.buildRequestData(this.getView().processId, newValue);
    var me = this;
    textArea.disable();
    mcs.Support.util.ajaxPostXMLCall(this.getView().url, requestData, function(success, response) {
      if (success) {
        var response = mcs.Support.util.parseXML(response.responseText);
        var success = Ext.DomQuery.selectValue('root/success', response);
        var message = Ext.DomQuery.selectValue('root/message', response);
        if (!success) {
          Ext.Msg.show({title:BpcCommon.Api.getTranslation('MONITOR_COMMENT_SEND_ERROR'), msg:message, buttons:Ext.Msg.OK, icon:Ext.MessageBox.ERROR});
          textArea.setValue(me.currentCommentValue);
        } else {
          me.currentCommentValue = newValue;
        }
      } else {
        textArea.setValue(me.currentCommentValue);
        var errorMsg;
        try {
          errorMsg = Ext.util.JSON.decode(response.responseText).message;
        } catch (e) {
          if (response.responseText.indexOf('404') > -1) {
            errorMsg = BpcCommon.Api.getTranslation('MONITOR_SERVER_NOT_FOUND');
          } else {
            errorMsg = BpcCommon.Api.getTranslation('MONITOR_UNKNOWN_ERROR');
          }
        }
        if (errorMsg.length === 0) {
          errorMsg = BpcCommon.Api.getTranslation('MONITOR_UNKNOWN_ERROR');
        }
        Ext.Msg.show({title:BpcCommon.Api.getTranslation('MONITOR_COMMENT_SEND_ERROR'), msg:errorMsg, buttons:Ext.Msg.OK, icon:Ext.MessageBox.ERROR});
      }
      textArea.enable();
    });
  } else {
    textArea.disable();
    textArea.enable();
  }
}, buildRequestData:function(processId, comment) {
  var requestData = mcs.Support.util.toBeginXML('root', 'atom');
  requestData += mcs.Support.util.toAtomXML('processID', processId);
  requestData += mcs.Support.util.toAtomXML('reference', '');
  requestData += mcs.Support.util.toAtomXML('operation', 'aperakViewWriteComment');
  requestData += mcs.Support.util.toAtomXML('commentField', comment);
  requestData += mcs.Support.util.toAtomXML('portletArchiveName', '');
  requestData += mcs.Support.util.toAtomXML('mandant', '');
  requestData += mcs.Support.util.toEndXML('root');
  return requestData;
}});
Ext.define('mcs.view.aperak.AdvancedTextArea', {extend:'Ext.panel.Panel', alias:'widget.advancedTextArea', requires:['mcs.view.aperak.AdvancedTextAreaController'], controller:'advancedTextAreaController', layout:{type:'vbox', align:'stretch'}, listeners:{focusleave:'saveData', afterrender:'onAfterrender'}, padding:10, processId:undefined, url:undefined, comment:undefined, buttons:[{xtype:'button', iconCls:BpcCommon.Icons.OkIcon, handler:'saveData'}, {xtype:'button', iconCls:BpcCommon.Icons.CancelIcon, 
handler:'onCancel'}], initComponent:function() {
  var me = this;
  var emptyText = this.emptyText ? this.emptyText : BpcCommon.Api.getTranslation('MONITOR_NO_COMMENTS_AVAILABLE');
  this.items = [{xtype:'textareafield', reference:'aperakTextArea', name:BpcCommon.Api.getTranslation('MONITOR_MESSAGE'), emptyText:emptyText, value:this.comment}];
  this.callParent(arguments);
}});
Ext.define('mcs.view.aperak.AperakContainerController', {extend:'Ext.app.ViewController', alias:'controller.aperakContainerController', requires:[], getConfigurationParams:function(monitorId) {
  var processId = BpcCommon.Api.getSetting(this.getView().moduleId, 'column_id');
  var baseUrl = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_baseUrl');
  if (mcs.Support.util.isEmpty(baseUrl) || mcs.Support.util.isEmpty(processId)) {
    Ext.log({msg:"Problem in aperak view: Couldn't find the configuration 'inubit_baseUrl' or 'column_id'. Please check the configuration of monitor.", level:'warn'});
  }
  return {baseUrl:baseUrl, processId:processId.toUpperCase()};
}, loadConfig:function(receivedConfig) {
  var defaultConfig = this.getDefaultConfig();
  if (receivedConfig) {
    if (typeof receivedConfig.center === 'undefined') {
      if (typeof receivedConfig.left !== 'undefined' || typeof receivedConfig.right !== 'undefined' || typeof receivedConfig.bottom !== 'undefined' || typeof receivedConfig.top !== 'undefined') {
        Ext.log({msg:'Problem to read the configuration of aperak container: center is not defined. Set the default configuration.', level:'warn'});
      }
      if (receivedConfig.endPoint) {
        defaultConfig.endPoint = receivedConfig.endPoint;
      }
      if (receivedConfig.repoUrl) {
        defaultConfig.repoUrl = receivedConfig.repoUrl;
      }
      return defaultConfig;
    } else {
      if (!receivedConfig.endPoint) {
        receivedConfig.endPoint = defaultConfig.endPoint;
      }
      if (!receivedConfig.repoUrl) {
        receivedConfig.repoUrl = defaultConfig.repoUrl;
      }
      return receivedConfig;
    }
  } else {
    return defaultConfig;
  }
}, createComponents:function(configuration) {
  var defaultHeight = configuration.height ? configuration.height / 3 : 150;
  var defaultWidth = configuration.width ? configuration.width / 3 : 150;
  var collapsible = typeof configuration.collapsible != 'undefined' ? configuration.collapsible : true;
  var autoScroll = typeof configuration.autoScroll != 'undefined' ? configuration.autoScroll : true;
  var split = typeof configuration.split != 'undefined' ? configuration.split : true;
  var config = {autoScroll:autoScroll, split:split, collapsible:collapsible};
  var items = [];
  var item, defaultConfig = null;
  if (typeof configuration.left !== 'undefined') {
    defaultConfig = Ext.apply({}, config, {region:'west', width:defaultWidth});
    item = this.parseObject(configuration.left, Ext.apply({}, configuration.left.config, defaultConfig));
    if (item) {
      items.push(item);
    }
  }
  if (typeof configuration.right !== 'undefined') {
    defaultConfig = Ext.apply({}, config, {region:'east', width:defaultWidth});
    item = this.parseObject(configuration.right, Ext.apply({}, configuration.right.config, defaultConfig));
    if (item) {
      items.push(item);
    }
  }
  if (typeof configuration.top !== 'undefined') {
    defaultConfig = Ext.apply({}, config, {region:'north', height:defaultHeight});
    item = this.parseObject(configuration.top, Ext.apply({}, configuration.top.config, defaultConfig));
    if (item) {
      items.push(item);
    }
  }
  if (typeof configuration.bottom !== 'undefined') {
    defaultConfig = Ext.apply({}, config, {region:'south', height:defaultHeight});
    item = this.parseObject(configuration.bottom, Ext.apply({}, configuration.bottom.config, defaultConfig));
    if (item) {
      items.push(item);
    }
  }
  items.push(this.parseObject(configuration.center, Ext.apply({}, {region:'center'}, configuration.center.config)));
  return items;
}, parseObject:function(layoutObject, containerConfig) {
  if (layoutObject.type === 'container') {
    return this.createContainer(containerConfig);
  } else if (layoutObject.type === 'documentPanel') {
    return this.createDocumentPanel(containerConfig);
  } else if (layoutObject.type === 'commentPanel') {
    return this.createCommentPanel(containerConfig);
  } else if (layoutObject.type === 'gridPanel') {
    return this.createGridPanel(containerConfig);
  } else if (layoutObject.type === 'infoViewer') {
    return this.createInfoPanel(containerConfig);
  } else if (layoutObject.type === 'tabPanel') {
    return this.createTabPanel(containerConfig);
  } else if (layoutObject.type === 'ediTree') {
    return this.createEdiTree(containerConfig);
  } else if (layoutObject.type === 'ediTextPanel') {
    return this.createTextPanel(containerConfig);
  } else if (layoutObject.type === 'ediMultiLinePanel') {
    return this.createMultiLinePanel(containerConfig);
  }
}, createContainer:function(containerConfig) {
  var items = containerConfig.item;
  var parsedItems = [];
  Ext.each(items, function(item) {
    parsedItems.push(this.parseObject(item, item.config));
  }, this);
  var layout = containerConfig.layout ? containerConfig.layout : {align:'stretch', type:'vbox'};
  return Ext.create('Ext.container.Container', Ext.apply({}, containerConfig, {layout:layout, items:parsedItems, autoScroll:true}));
}, createCommentPanel:function(config) {
  var settings = this.getView().settings;
  var baseUrl = settings.baseUrl;
  if (!mcs.Support.util.isEmpty(baseUrl)) {
    var aperakConfig = this.getView().aperakConfig;
    var processIDKey = settings.processId;
    var processId = this.getView().record.get(processIDKey.toUpperCase());
    var inubitProxyId = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_proxyId');
    var url = BpcCommon.Api.getBackendUrl(inubitProxyId) + baseUrl + aperakConfig.endPoint;
    return Ext.createByAlias('widget.advancedTextArea', Ext.apply({}, config, {processId:processId, url:url, comment:Ext.DomQuery.selectValue('Header/CommentField', this.getView().aperakData)}));
  } else {
    Ext.log({msg:"Couldn't find the configuration of 'inubit_baseUrl' and couldn't create the comment panel. Please check the configuration of monitor.", level:'warn'});
    return null;
  }
}, createDocumentPanel:function(config) {
  try {
    var processIDKey = this.getView().settings.processId;
    var processId = this.getView().record.get(processIDKey.toUpperCase());
    var docButtons = this.createDocButtons(processId);
    var layout = config && config.layout ? config.layout : {align:'middle', type:'hbox'};
    return Ext.create('Ext.container.Container', {items:docButtons, layout:layout, padding:10, autoScroll:true, defaults:{autoScroll:true, iconAlign:'top', height:75}, listeners:{resize:function(container, width, height, oldWidth, oldHeight, eOpts) {
      if (oldWidth > width) {
        var items = container.items.items;
        var containerWidth = 0;
        Ext.each(items, function(item) {
          containerWidth += item.getWidth();
        });
        if (containerWidth > width) {
          container.removeAll();
          container.add(docButtons);
        }
      }
    }}}, this);
  } catch (e) {
    BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('MONITOR_ERROR_READING_CONFIGURATIONS'));
  }
}, createDocButtons:function(processId) {
  var iconMapping = {'pdf':'fa-file-pdf', 'text':'fa-file-alt', 'word':'fa-file-word', 'other':'fa-file'};
  var docButtons = [];
  var docs = Ext.DomQuery.jsSelect('Documents/Document', this.getView().aperakData);
  Ext.each(docs, function(doc) {
    var url = Ext.DomQuery.selectValue('URL', doc);
    var docType = url.split('.').pop();
    docButtons.push({xtype:'button', text:Ext.DomQuery.selectValue('Name', doc), iconCls:iconMapping[docType] ? BpcCommon.util.Icons.getBpcIconCls(iconMapping[docType]) : BpcCommon.util.Icons.getBpcIconCls(iconMapping['other']), handler:this.downloadFromRepository.bind(this, url), tooltip:Ext.DomQuery.selectValue('Tooltip', doc, Ext.DomQuery.selectValue('Name', doc)), style:{marginRight:'5px'}});
  }, this);
  var refMsgType = Ext.DomQuery.selectValue('ReferenceMessage/MessageType', this.getView().aperakData);
  docButtons.push({xtype:'tbspacer', flex:1}, {xtype:'button', text:this.getView().mode, iconCls:BpcCommon.util.Icons.getBpcIconCls('fa-download'), handler:this.directTextDownload.bind(this, 'aperak-' + processId + '.txt', Ext.DomQuery.selectValue('OriginalMessage', this.getView().errorMessage)), style:{marginRight:'5px'}}, {xtype:'button', text:refMsgType ? refMsgType : 'Quellnachricht', iconCls:BpcCommon.util.Icons.getBpcIconCls('fa-download'), handler:this.directTextDownload.bind(this, refMsgType + 
  '-' + processId + '.txt', Ext.DomQuery.selectValue('ReferenceMessage/OriginalMessage', this.getView().aperakData))});
  return docButtons;
}, directTextDownload:function(filename, text) {
  var element = document.createElement('a');
  element.setAttribute('href', 'data:application/edifact;charset\x3dutf-8,' + encodeURIComponent(text));
  element.setAttribute('download', filename);
  document.body.appendChild(element);
  element.click();
  document.body.removeChild(element);
}, downloadFromRepository:function(repoUrl) {
  var inubitProxyId = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_proxyId');
  var path = BpcCommon.Api.getBackendUrl(inubitProxyId);
  window.open(path + repoUrl, '_blank');
}, createGridPanel:function(config) {
  var data = Ext.DomQuery.selectNode('Errorlist', this.getView().errorMessage);
  return Ext.createByAlias('widget.gridPanel', Ext.apply({}, config, {errorList:data, flex:1, minHeight:100}));
}, createInfoPanel:function(config) {
  var refMsgType = Ext.DomQuery.selectValue('ReferenceMessage/MessageType', this.getView().aperakData);
  var refMsgVersion = Ext.DomQuery.selectValue('ReferenceMessage/MessageVersion', this.getView().aperakData);
  var errorSummary = Ext.DomQuery.selectValue('Summary', this.getView().errorMessage);
  var identificatorCode = Ext.DomQuery.selectValue('ReferenceMessage/Identificator/Code', this.getView().aperakData);
  var identificatorText = Ext.DomQuery.selectValue('ReferenceMessage/Identificator/Text', this.getView().aperakData);
  var data = {refMsgType:refMsgType, refMsgVersion:refMsgVersion, errorSummary:errorSummary, identificatorCode:identificatorCode, identificatorText:identificatorText};
  config.collapsible = false;
  return Ext.createByAlias('widget.infoPanel', Ext.apply({}, config, {inputData:data}));
}, createTabPanel:function(config) {
  var tabs = [];
  Ext.each(config.item, function(item) {
    tabs.push(this.parseObject(item, item.config));
  }, this);
  return Ext.apply({xtype:'tabpanel'}, config, {items:tabs});
}, createEdiTree:function(config) {
  if (this.getView().aperakData) {
    var treeData = Ext.DomQuery.selectNode('ReferenceMessage/InterchangeMessage', this.getView().aperakData);
  } else {
    treeData = {};
  }
  return Ext.createByAlias('widget.treePanel', Ext.apply({}, config, {treeData:treeData, scrollable:true}));
}, createTextPanel:function(config) {
  return Ext.create('Ext.Component', Ext.apply({}, config, {autoEl:{tag:'pre', style:'overflow: auto;', children:[{tag:'code', style:'display: inline;', html:Ext.util.Format.htmlEncode(Ext.DomQuery.selectValue('ReferenceMessage/OriginalMessage', this.getView().aperakData))}]}}));
}, createMultiLinePanel:function(config) {
  var value = Ext.DomQuery.selectValue('ReferenceMessage/OriginalMessage', this.getView().aperakData);
  if (!value) {
    value = '';
  }
  var newLineRegExp = config.ediNewLineRegExp ? new RegExp(config.ediNewLineRegExp, 'g') : new RegExp('["\']', 'g');
  return Ext.create('Ext.Component', Ext.apply({}, config, {autoEl:{tag:'pre', style:'overflow: auto;', children:[{tag:'code', style:'display: inline;', html:value.replace(newLineRegExp, "'\x3cbr/\x3e")}]}}));
}, getDefaultConfig:function() {
  return {'endPoint':'VPMA_VPD_AJAX_Listener', 'repoUrl':'/ibis/servlet/Repository/Root/VPMA/', 'center':{'type':'container', 'config':{'layout':{'align':'stretch', 'type':'vbox'}, 'item':[{'type':'gridPanel', 'config':{'columns':[{'dataIndex':'Code', 'header':BpcCommon.Api.getTranslation('MONITOR_ERROR_CODE'), 'width':80}, {'dataIndex':'Message', 'header':BpcCommon.Api.getTranslation('MONITOR_ERROR_MSG')}, {'dataIndex':'Text', 'header':BpcCommon.Api.getTranslation('MONITOR_ERROR_TEXT'), 'cellWrap':true}]}}, 
  {'type':'documentPanel', 'config':{}}]}}, 'left':{'type':'tabPanel', 'config':{'title':'EDI', 'item':[{'type':'ediMultiLinePanel', 'config':{'ediNewLineRegExp':'["\']', 'title':'EDI Multiline'}}, {'type':'ediTextPanel', 'config':{'title':'EDI'}}, {'type':'ediTree', 'config':{'title':BpcCommon.Api.getTranslation('MONITOR_TREE')}}], 'width':300}}, 'top':{'type':'infoViewer', 'config':{'height':80, 'split':false, 'autoScroll':false}}};
}});
Ext.define('mcs.view.aperak.AperakContainer', {extend:'Ext.container.Container', alias:'widget.aperakContainer', requires:['mcs.view.aperak.AperakContainerController'], controller:'aperakContainerController', mixins:['BpcCommon.mixin.PsPluginMixin'], layout:'fit', localized:{title:'MONITOR_APERAK_ERROR_VIEW'}, autoScroll:true, aperakConfig:undefined, record:undefined, settings:undefined, aperakData:undefined, errorMessage:undefined, mode:undefined, initComponent:function() {
  this.moduleId = this.getValueFromPluginConfiguration('instanceId', true);
  this.record = this.getValueFromPluginConfiguration('record', true);
  this.settings = this.getController().getConfigurationParams(this.moduleId);
  this.aperakConfig = this.getController().loadConfig(this.aperakConfig);
  var subItems = this.getController().createComponents(this.aperakConfig);
  var items = [{xtype:'container', layout:'border', reference:'aperakBorderContainer', items:subItems}];
  Ext.apply(this, {items:items});
  this.callParent(arguments);
}, setItems:function(items) {
  var container = this.lookupReference('aperakBorderContainer');
  container.add(items);
}});
Ext.define('mcs.view.aperak.AperakView', {extend:'Ext.panel.Panel', alias:'widget.mcsAperakView', controller:'mcsAperakViewController', title:'EDI Fehleransicht', mixins:['BpcCommon.mixin.PsPluginMixin'], aperakConfig:undefined, layout:'fit', items:[{style:'display: flex;justify-content: center;align-items: center;', localized:{html:{tpl:'\x3ci class\x3d"fa fa-spinner fa-pulse fa-5x fa-fw"\x3e\x3c/i\x3e\x3cbr\x3e\x3cspan\x3e{MONITOR_LOADING_VIEW}\x3c/span\x3e', keys:['MONITOR_LOADING_VIEW']}}}], 
initComponent:function() {
  var pluginDisabled = false;
  if (this.ownerCt) {
    var win = this.ownerCt.up('window');
    if (!win) {
      pluginDisabled = true;
    }
  }
  if (pluginDisabled) {
    this.hidden = true;
    this.callParent(arguments);
  } else {
    this.moduleId = this.getValueFromPluginConfiguration('instanceId', true);
    this.record = this.getValueFromPluginConfiguration('record', true);
    this.settings = this.getConfigurationParams();
    this.aperakConfig = this.getController().loadConfig(this.aperakConfig);
    this.callParent(arguments);
    this.getController().buildAndRequestAperakData();
  }
}, getConfigurationParams:function() {
  var processId = BpcCommon.Api.getSetting(this.moduleId, 'column_id');
  var baseUrl = BpcCommon.Api.getSetting(this.moduleId, 'inubit_baseUrl');
  if (mcs.Support.util.isEmpty(baseUrl) || mcs.Support.util.isEmpty(processId)) {
    Ext.log({msg:"Problem in aperak view: Couldn't find the configuration 'inubit_baseUrl' or 'column_id'. Please check the configuration of monitor.", level:'warn'});
  }
  processId = '' + processId;
  return {baseUrl:baseUrl, processId:processId.toUpperCase()};
}});
Ext.define('mcs.view.aperak.AperakViewController', {extend:'Ext.app.ViewController', alias:'controller.mcsAperakViewController', loadConfig:function(receivedConfig) {
  var defaultConfig = this.getDefaultConfig();
  if (receivedConfig) {
    if (typeof receivedConfig.center === 'undefined') {
      if (typeof receivedConfig.left !== 'undefined' || typeof receivedConfig.right !== 'undefined' || typeof receivedConfig.bottom !== 'undefined' || typeof receivedConfig.top !== 'undefined') {
        Ext.log({msg:'Problem to read the configuration of aperak container: center is not defined. Set the default configuration.', level:'warn'});
      }
      if (receivedConfig.endPoint) {
        defaultConfig.endPoint = receivedConfig.endPoint;
      }
      if (receivedConfig.repoUrl) {
        defaultConfig.repoUrl = receivedConfig.repoUrl;
      }
      return defaultConfig;
    } else {
      if (!receivedConfig.endPoint) {
        receivedConfig.endPoint = defaultConfig.endPoint;
      }
      if (!receivedConfig.repoUrl) {
        receivedConfig.repoUrl = defaultConfig.repoUrl;
      }
      return receivedConfig;
    }
  } else {
    return defaultConfig;
  }
}, buildAndRequestAperakData:function() {
  var view = this.getView();
  var settings = view.settings || {};
  var baseUrl = settings.baseUrl;
  var config = view.aperakConfig;
  if (!mcs.Support.util.isEmpty(baseUrl)) {
    var processId = view.record.getId();
    var requestData = this.buildRequestData(processId);
    var endPoint = '';
    if (mcs.Support.util.isEmpty(config.endPoint)) {
      endPoint = BpcCommon.Api.getSetting(view.moduleId, 'inubit_aperakEndPoint');
      if (mcs.Support.util.isEmpty(endPoint)) {
        Ext.log({msg:"Problem in detail container: Couldn't find the configuration 'inubit_aperakEndPoint'. " + 'Please check the configuration of monitor.', level:'warn'});
      }
    } else {
      endPoint = config.endPoint;
    }
    var inubitProxyId = BpcCommon.Api.getSetting(view.moduleId, 'inubit_proxyId');
    var url = BpcCommon.Api.getBackendUrl(inubitProxyId) + baseUrl + endPoint;
    this.sendAperakRequest(url, requestData);
  } else {
    Ext.log({msg:"Problem in detail container: Couldn't find the configuration 'baseUrl' in monitor. " + 'Please check the configuration of monitor.', level:'warn'});
  }
}, buildRequestData:function(processId) {
  var requestData = mcs.Support.util.toBeginXML('root', 'atom');
  requestData += mcs.Support.util.toAtomXML('processID', processId);
  requestData += mcs.Support.util.toAtomXML('reference', '');
  requestData += mcs.Support.util.toAtomXML('operation', 'aperakView');
  requestData += mcs.Support.util.toAtomXML('portletArchiveName', '');
  requestData += mcs.Support.util.toAtomXML('mandant', this.getTenant());
  requestData += mcs.Support.util.toAtomXML('gridID', this.getGridId());
  requestData += mcs.Support.util.toEndXML('root');
  return requestData;
}, getTenant:function() {
  var tenant = '';
  var pmMandant = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_pmMandant');
  if (!mcs.Support.util.isEmpty(pmMandant)) {
    tenant = pmMandant;
  }
  return tenant;
}, getGridId:function() {
  var gridId = '';
  var readGrid = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_dbGridId');
  if (!mcs.Support.util.isEmpty(readGrid)) {
    gridId = readGrid;
  }
  return gridId;
}, sendAperakRequest:function(url, requestData) {
  var me = this, view = this.getView();
  var config = view.aperakConfig;
  var unlockFn = BpcCommon.Util.blockComponentForAsyncAction(this.getView().getId(), 'id');
  mcs.Support.util.ajaxPostXMLCall(url, requestData, function(success, response) {
    var errorMsg;
    unlockFn();
    if (success) {
      var aperakData = mcs.Support.util.parseXML(response.responseText);
      var displayed = Ext.DomQuery.selectValue('Header/Display', aperakData);
      if (displayed === 'true') {
        var errorMessages = Ext.DomQuery.select('Errorview/ErrorMessage', aperakData);
        var cmpArray = [];
        var title = '';
        Ext.each(errorMessages, function(message) {
          if (!mcs.Support.util.isEmpty(message.childNodes)) {
            title = Ext.DomQuery.selectValue('MessageType', message);
            var container = Ext.applyIf({xtype:'aperakContainer', aperakConfig:config, aperakData:aperakData, errorMessage:message, title:title + BpcCommon.Api.getTranslation('MONITOR_ERROR_VIEW'), mode:title}, me.getView().initialConfig);
            cmpArray.push(container);
          }
        });
        if (cmpArray.length > 0) {
          me.updateContent({xtype:'tabpanel', items:cmpArray});
          me.getView().setTitle(BpcCommon.Api.getTranslation('MONITOR_EDI_ERROR_VIEWS') + '(' + cmpArray.length + ')');
        } else {
          me.getView().setTitle(title + BpcCommon.Api.getTranslation('MONITOR_ERROR_VIEW'));
        }
      } else {
        view.removeAll();
        var status = Ext.DomQuery.selectValue('Header/Status', aperakData);
        if (status === 'Error') {
          errorMsg = Ext.DomQuery.selectValue('Header/ErrorMessage', aperakData);
          if (errorMsg.length === 0) {
            me.updateContent(me.createErrorAperakComponents('Unbekannter Fehler.'));
          } else {
            me.updateContent(me.createErrorAperakComponents(errorMsg));
          }
        } else {
        }
        view.disable();
      }
    } else {
      try {
        errorMsg = Ext.util.JSON.decode(response.responseText).message;
      } catch (e) {
        if (response.responseText && response.responseText.indexOf('404') > -1) {
          errorMsg = BpcCommon.Api.getTranslation('MONITOR_SERVER_NOT_FOUND');
        } else {
          errorMsg = BpcCommon.Api.getTranslation('MONITOR_UNKNOWN_ERROR');
        }
      }
      me.updateContent(me.createErrorAperakComponents(errorMsg));
    }
  });
}, createErrorAperakComponents:function(errorMsg) {
  return Ext.create('Ext.container.Container', {title:'Aperak Fehleransicht', layout:{type:'hbox', align:'stretch'}, padding:10, items:[{xtype:'box', html:'\x3cp\x3e\x3c/p\x3e\x3ci class\x3d"fa fa-exclamation-triangle" style\x3d"color: #D49A6A; ' + 'font-size: 18px; margin-right: 3px;"\x3e\x3c/i\x3e\x3c/p\x3e'}, {xtype:'box', html:'\x3cp\x3e' + BpcCommon.Api.getTranslation('MONITOR_EROOR_LOADING_APARAK_VIEW') + ': ' + errorMsg + '\x3c/p\x3e', style:{marginLeft:'10px'}}]});
}, updateContent:function(cmp) {
  if (cmp) {
    this.getView().removeAll();
    return this.getView().add(cmp);
  }
}, getDefaultConfig:function() {
  return {'endPoint':'VPMA_VPD_AJAX_Listener', 'repoUrl':'/ibis/servlet/Repository/Root/VPMA/', 'center':{'type':'container', 'config':{'layout':{'align':'stretch', 'type':'vbox'}, 'item':[{'type':'gridPanel', 'config':{'columns':[{'dataIndex':'Code', 'header':BpcCommon.Api.getTranslation('MONITOR_ERROR_CODE'), 'width':80}, {'dataIndex':'Message', 'header':BpcCommon.Api.getTranslation('MONITOR_ERROR_MSG')}, {'dataIndex':'Text', 'header':BpcCommon.Api.getTranslation('MONITOR_ERROR_TEXT'), 'cellWrap':true}]}}, 
  {'type':'documentPanel', 'config':{}}]}}, 'left':{'type':'tabPanel', 'config':{'title':'EDI', 'item':[{'type':'ediMultiLinePanel', 'config':{'ediNewLineRegExp':'["\']', 'title':'EDI Multiline'}}, {'type':'ediTextPanel', 'config':{'title':'EDI'}}, {'type':'ediTree', 'config':{'title':BpcCommon.Api.getTranslation('MONITOR_TREE')}}], 'width':300}}, 'top':{'type':'infoViewer', 'config':{'height':80, 'split':false, 'autoScroll':false}}};
}});
Ext.define('mcs.view.aperak.GridPanelController', {extend:'Ext.app.ViewController', alias:'controller.gridPanelController', init:function() {
  this.callParent(arguments);
}, loadData:function(dataInXML, store) {
  var data = this.convertDataToJson(dataInXML);
  store.loadData(data);
}, convertDataToJson:function(dataInXML) {
  var errorList = [];
  if (dataInXML) {
    var errorListXML = dataInXML.getElementsByTagName('Error');
    for (var i = 0; i < errorListXML.length; i++) {
      var error = {};
      var children = errorListXML[i].childNodes;
      for (var j = 0; j < children.length; j++) {
        var nodeName = children[j].nodeName;
        error[nodeName] = children[j].textContent;
      }
      errorList.push(error);
    }
  }
  return errorList;
}});
Ext.define('mcs.view.aperak.GridPanel', {extend:'Ext.grid.Panel', requires:['Ext.grid.column.*', 'mcs.view.aperak.GridPanelController'], alias:'widget.gridPanel', controller:'gridPanelController', loadMask:true, viewConfig:{localized:{emptyText:'MONITOR_NO_DATA_FOUND'}}, forceFit:true, columns:undefined, errorList:undefined, initComponent:function() {
  this.store = this.createStore(this.columns);
  this.getController().loadData(this.errorList, this.store);
  this.callParent(arguments);
}, createStore:function(columns) {
  var store = Ext.create('Ext.data.Store', {reader:{type:'json'}, fields:columns});
  return store;
}});
Ext.define('mcs.view.aperak.InfoPanel', {extend:'Ext.container.Container', alias:'widget.infoPanel', layout:{type:'vbox', align:'stretch'}, padding:20, inputData:undefined, initComponent:function() {
  this.items = [{xtype:'container', layout:{type:'hbox', align:'stretch'}, items:[{xtype:'box', html:this.inputData.refMsgType + ' Version: \x3cb\x3e' + this.inputData.refMsgVersion + '\x3c/b\x3e'}, {xtype:'tbspacer', flex:1}, {xtype:'box', html:this.inputData.identificatorCode && this.inputData.identificatorText ? BpcCommon.Api.getTranslation('MONITOR_CHECK_IDENTIFIER') + ': [' + this.inputData.identificatorCode + '] ' + this.inputData.identificatorText + ' ' : ''}]}, {xtype:'container', layout:{type:'hbox', 
  align:'stretch'}, margins:'0 5 0 5', items:[{xtype:'tbspacer', flex:1}, {xtype:'box', html:this.inputData.errorSummary ? '\x3cb\x3e' + this.inputData.errorSummary + '\x3c/b\x3e' : ''}]}];
  this.callParent(arguments);
}});
Ext.define('mcs.view.aperak.TreePanel', {extend:'Ext.tree.Panel', alias:'widget.treePanel', rootVisible:false, treeData:undefined, listeners:{afterrender:function(tree) {
  tree.expandPath('/root/' + tree.treeData.nodeName);
}, itemexpand:{fn:function() {
  var me = this, c = me.getColumns()[0];
  c.autoSize();
}}}, scrollable:true, nodeToJsonTree:function(node) {
  var jsonTree = {text:node.nodeName, draggable:false};
  var textValue = '';
  Ext.each(node.childNodes, function(item) {
    if (item.nodeType === 3 && item.textContent.trim() !== '') {
      textValue = textValue + item.textContent.trim() + ' ';
      textValue = textValue.replace(/</g, '\x26lt;');
      textValue = textValue.replace(/>/g, '\x26gt;');
    }
  }, this);
  var attributes = '';
  if (node.attributes) {
    for (var i = 0; i < node.attributes.length; i++) {
      attributes = attributes + node.attributes.item(i).name + '\x3d' + node.attributes.item(i).value + ' ';
    }
  }
  if (attributes.length > 0) {
    jsonTree.text = jsonTree.text + ' (' + attributes + ')';
  }
  if (textValue.length > 0) {
    jsonTree.text = jsonTree.text + ' : \x3cb\x3e' + textValue + '\x3c/b\x3e';
  }
  if (!node.childElementCount || node.childElementCount < 1) {
    jsonTree.leaf = true;
    jsonTree.iconCls = '';
    jsonTree.icon = Ext.BLANK_IMAGE_URL;
  } else {
    jsonTree.leaf = false;
    jsonTree.icon = Ext.BLANK_IMAGE_URL;
    jsonTree.children = [];
    Ext.each(node.childNodes, function(node) {
      if (node.nodeType !== 3) {
        jsonTree.children.push(this.nodeToJsonTree(node));
      }
    }, this);
  }
  return jsonTree;
}, initComponent:function() {
  var children = this.nodeToJsonTree(this.treeData);
  this.store = Ext.create('Ext.data.TreeStore', {root:{expanded:true, autoScroll:true, children:children}});
  this.callParent(arguments);
}});
